/** The Cube Server will append predefined variables above :) **/

$(document).ready(function(){

/***********************GLOBAL DECLARATIONS*****************************/
var __cors__ = "https://cors-anywhere.herokuapp.com";

/* Data Holders */
var _environment_data = "";
var _cube_data = "";

/* Flags */
var _initialized = false;
var _download_mode = "";

/* SYSTEM */
var _json_get_environment_data = __host__ + "/cmd/system/get-environment-data";
var _json_get_cube_data = __host__ + "/cmd/system/get-cube-data";
var _json_get_server_status = __host__ + "/cmd/system/get-status";
var _json_get_server_result = __host__ + "/cmd/system/get-result";

/* REPOSITORY */
var _json_get_section_lists = __host__ + "/cmd/repository/get-sections";
var _json_get_main_lists = __host__ + "/cmd/repository/get-main-lists";
var _json_get_section_packages = __host__ + "/cmd/repository/get-section-packages";
var _json_package_search = __host__ + "/cmd/repository/find-package-starts-with";
var _json_find_package = __host__ + "/cmd/repository/find-package";
var _json_get_next = __host__ + "/cmd/repository/get-next";
var _json_scan_repositories = __host__ + "/cmd/repository/scan-repositories";
var _json_get_available_packages = __host__ + "/cmd/repository/get-available-packages";
var _json_get_installed_packages = __host__ + "/cmd/repository/get-installed-packages";
var _json_get_upgradable_packages = __host__ + "/cmd/repository/get-upgradable-packages";
var _json_get_downloaded_packages = __host__ + "/cmd/repository/get-downloaded-packages";
var _json_get_package_dependencies = __host__ + "/cmd/repository/get-package-dependencies";
var _json_get_satisfied_downloaded_packages = __host__ + "/cmd/repository/get-satisfied-downloaded-packages";
var _json_get_marked_packages = __host__ + "/cmd/repository/get-marked-packages";
var _json_mark_package = __host__ + "/cmd/repository/mark-package";
var _json_unmark_package = __host__ + "/cmd/repository/unmark-package";

/* DOWNLOAD */
var _json_get_package_download_status = __host__ + "/cmd/download/get-download-status";
var _json_download_package = __host__ + "/cmd/download/download-package";
var _json_download_repository = __host__ + "/cmd/download/download-repository";
var _json_stop_download = __host__ + "/cmd/download/stop-download";
var _json_get_download_package_result = __host__ + "/cmd/download/get-download-package-result";
var _json_get_download_repository_result = __host__ + "/cmd/download/get-download-repository-result";

/* INSTALL */
var _json_install_package = __host__ + "/cmd/install/install-package";
var _json_get_install_package_result = __host__ + "/cmd/install/get-install-package-result";

/* PROJECT */
var _json_get_projects = __host__ + "/cmd/project/get-projects";
var _json_open_project = __host__ + "/cmd/project/open-project";
var _json_create_project = __host__ + "/cmd/project/create-project";
var _json_get_current_project = __host__ + "/cmd/project/get-current-project";

/* UPDATE */
var _json_update_system = __host__ + "/cmd/update/update-system";
var _json_get_update_system_result = __host__ + "/cmd/update/get-update-system-result";
var _json_update_project = __host__ + "/cmd/update/update-project";
var _json_get_update_project_result = __host__ + "/cmd/update/get-update-project-result";

/* SOURCE */
var _json_add_ppa_repository = __host__ + "/cmd/source/add-ppa-repository";
var _json_check_ppa_exists = __host__ + "/cmd/source/check-ppa-exists";

/* CONFIGURATION */
var _json_get_configuration_entries = __host__ + "/cmd/configuration/get-configuration-entries";
var _json_save_configuration_entries = __host__ + "/cmd/configuration/save-configuration-entries";
var _json_open_sources_list_file = __host__ + "/cmd/configuration/open-sources-list-file";


/***********************QUERY FUNCTIONS*****************************/

function get_server_status ()
{
	$.getJSON( _json_get_server_status )
	.done(function(result){
		_system_status = result
		if ( _system_status.repository_scanning == "true" )
			on_scan_repository_started();
		if ( _system_status.repository_scanned == "true" && !_initialized )
			on_scan_repository_finished();
		if ( _system_status.package_downloading == "true" || _system_status.repository_downloading == "true" )
			on_download_started();
		if ( _system_status.package_installing == "true" ) 
			on_install_started();
		if ( _system_status.project_opened == "false" )
			on_project_startup();

	})
	.fail(function(){
		console.log("get_server_status failed");
	});
}

function get_package_items ( type , value )
{
	var json_request_link = "";

	$("#package-list-end-div").attr("is-end","false");
	
	if ( type == "main-list" )
	{
		if ( value == "available" )
			json_request_link = _json_get_available_packages;
		else if ( value == "installed" )
			json_request_link = _json_get_installed_packages;
		else if ( value == "upgradable" )
			json_request_link = _json_get_upgradable_packages;
		else if ( value == "downloaded" )
			json_request_link = _json_get_downloaded_packages;
		else if ( value == "marked-to-download")
			json_request_link = _json_get_marked_packages+"?type=to-download";		
		else if ( value == "marked-to-install")
			json_request_link = _json_get_marked_packages+"?type=to-install";
	}
	else if ( type == "section-list" )
	{
		json_request_link = _json_get_section_packages + "?section=" + value;
	}
	else if ( type == "package-search" )
	{
		json_request_link = _json_package_search + "?package=" +value;		
	}
	
	$("#package-list").html("");
	
	
    //Get Packages
	$.getJSON(json_request_link)
	.done(function(result){
		if ( result.length == 0 )
		{    
			if ( $("#package-list-end-div").attr("is-end") == "false" )
    			$("#package-list").append("<div class='alert alert-danger text-center'>No packages</div>");
			$("#package-list-end-div").attr("is-end","true");
		}
		else
		{
    		for ( var i = 0; i < result.length ; i++ )
				$("#package-list").append(package_item ( result[i] ));			
		}
	})
	.fail(function(){    		
		alert("package-list json failed");
		$("#package-list").html("<div class='alert alert-danger text-center'>Oh snap! Something weird happen while fetching apps! Please try again later.</div>");
	});	
		
}

function get_next ()
{
	$.getJSON( _json_get_next + "?type=current&count=10" )
	.done(function(result){
		if ( result.length == 0 )
		{
			if ( $("#package-list-end-div").attr("is-end") == "false" )
				$("#package-list").append("<p></p><div class='alert alert-danger text-center'>No more packages to load</div>");
			$("#package-list-end-div").attr("is-end","true");
		}
		else
		{
			for ( var i = 0; i < result.length ; i++ )
				$("#package-list").append(package_item ( result[i] ));
		}
	})
	.fail(function(){    		
		alert("package-list json failed");
		$("#package-list").html("<div class='alert alert-danger text-center'>Oh snap! Something weird happen while fetching apps! Please try again later.</div>");
	});
}

function get_section_lists ()
{
	 //Get Sections
	$.getJSON( _json_get_section_lists )
	.done(function(result){
		$("#section-list").html("");
		for ( var i = 0; i < result.length ; i++ )
			$("#section-list").append(section_item( result[i] ));
	})
	.fail(function(){
		alert("section list json failed");
	});
}

function get_main_lists ()
{
	//Get Main Lists
	$.getJSON( _json_get_main_lists )
	.done(function(result){
		$("#main-list").html("");
		for ( var i = 0; i < result.length ; i++ )
			$("#main-list").append(main_list_item( result[i] ));
	})
	.fail(function(){
		alert("get-main-list json failed");
	});
}



/***********************HTML TEMPLATES*****************************/

function package_item ( p )
{
	var html = "<li class='media package-item' id = '"+p.name+"' package-item-name='"+p.name+"'>"+	
					"<div class='media-left'>"+					
						"<img id='package-item-image' class='media-object' height='48' width='48' src='https://apps.ubuntu.com/site_media/icons/2015/03/"+p.name+".png' onError=\"this.onerror=null;this.src='assets/images/package.png';\">"+
					"</div>"+
					package_item_body(p)+
				"</li>";
	return html;
}

function package_item_body( p)
{
	var html = "<div id='package-item-body-"+p.name+"' class='media-body'>"+
					"<div package-item-name='"+p.name+"' class='package-item-body col-md-8'>"+
						"<h4 class='media-heading'>"+p.name+
							"  <small><span class='label label-success'>"+p.size+"</span></small>";

	if ( p.status == "Upgradable" )
		html += " <small><span class='label label-primary'>"+p.status+"</span></small>"; 
	
	html += "</h4>"+p.description+"</div>";	

	//Mark package button
	if ( p.status != "Installed" )
	{		
		var class_data = "";
		var id = "";
		if ( p.status == "Upgradable" || p.status == "Available" )
		{			
			if ( p.marked == "false" )
			{
				class_data="mark-to-download-btn sr-only";
				id = "mark-to-download-btn-"+p.name;
			}
			else
			{
				class_data="unmark-to-download-btn";
				id = "unmark-to-download-btn-"+p.name;
			}
		}
		else if ( p.status == "Downloaded" )
		{
			if ( _environment_data.original_computer == "false" )
			{
				//Unknown ID and Class
				id = "~mark-to-install-btn-"+p.name;
				class_data = "mark-to-install-btn sr-only";				
			}
			else if ( p.marked == "false" )
			{
				class_data = "mark-to-install-btn sr-only";
				id = "mark-to-install-btn-"+p.name;
			}
			else
			{
				class_data="unmark-to-install-btn";
				id = "unmark-to-install-btn-"+p.name;				
			}
		}

		
		html += "<div class='col-md-1'>"+
					"<button package-item-name='"+p.name+"' id='"+id+"' class='"+class_data+" btn btn-success'>"+
						"<span class='glyphicon glyphicon-ok'></span>"+
					"</button>"+
				"</div>";		
	}
	else
		html += "<div class='col-md-1'>"+"</div>";

	if ( p.status == "Upgradable" || p.status == "Available" )
		html += "<div class='col-md-3'>"+
					"<button package-item-name='"+p.name+"' class='package-item-btn form-control btn btn-default col-md-3'>Download</button>"+
				"</div>";

	else if ( p.status == "Installed" )
		html += "<div class='col-md-3'>"+
					"<button package-item-name='"+p.name+"' class='package-item-btn form-control btn btn-success'>Installed</button>"+
				"</div>";

	else if ( p.status == "Downloaded" && _environment_data.original_computer == "true" )
		html += "<div class='col-md-3'>"+
					"<button package-item-name='"+p.name+"' class='package-item-btn form-control btn btn-primary'>Install</button>"+
				"</div>";

	else if ( p.status == "Downloaded" && _environment_data.original_computer == "false" )
		html += "<div class='col-md-3'>"+
					"<button package-item-name='"+p.name+"' class='package-item-btn form-control btn btn-warning'>Downloaded</button>"+
				"</div>";

	html += "</div>";

	return html;
}

function package_dependency_item( p )
{
	var html = "<li class='media package-dependency-item'>"+
					"<div class='media-left'>"+
						"<img id='package-item-image' class='media-object' height='48' width='48' src='https://apps.ubuntu.com/site_media/icons/2015/03/"+p.name+".png' onError=\"this.onerror=null;this.src='assets/images/package.png';\">"+
					"</div>"+
					"<div class='media-body'>"+
						"<div class='col-md-9'>"+
							"<h4 class='media-heading'>"+p.name+
							"  <small><span class='label label-success'>"+p.size+"</span></small>";

	if ( p.status == "Upgradable" )
		html += " <small><span class='label label-primary'>"+p.status+"</span></small>"; 
	
	html += "</h4>"+p.description+"</div></li>";
	
	return html;
}

function preview_modal_header ( p , size)
{
	var size_html = "";
	if ( size != undefined )
		size_html = "<div class='pull-right btn btn-default'>"+size+"</div>";

	var html = "<div class='media package-dependency-item'>"+
					"<div class='media-left'>"+
						"<img id='package-item-image' class='media-object' height='48' width='48' src='https://apps.ubuntu.com/site_media/icons/2015/03/"+p.name+".png' onError=\"this.onerror=null;this.src='assets/images/package.png';\">"+
					"</div>"+
					"<div class='media-body'>"+
						"<div class='col-md-9'>"+
							"<h4 class='media-heading'>"+p.name+"</h4>"+
							p.description+
						"</div>"+
						size_html+
					"</div>"+
				"</div>";
	
	return html;	
}

function section_item ( s )
{
	var html = "<a section-list-item-name='" + s.name + "' section-list-item-desc='" + s.description + "' class='list-group-item section-list-item'>"+
					"<span class='badge'>"+s.count+"</span>"+
					s.description+
				"</a>"

	return html;
}

function main_list_item ( l )
{
	var html = "<a main-list-item-name='" + l.name + "' main-list-item-desc='" +l.description + "' class='list-group-item main-list-item'>"+
					"<span class='badge'>"+l.count+"</span>"+
					l.description+
				"</a>"

	return html;
}

function download_result_table ( result )
{
	var rows = "";

	for ( var i = 0; i < result.length; i++ )
	{
		rows += "<tr>"+
					"<td>"+result[i].name+"</td>"+
					"<td>"+result[i].size+"</td>"+
					"<td>"+result[i].error_message+"</td>"+
				"</tr>";
	}

	var html = "<table class='table table-default'>"+
					"<th>Item</th>"+
					"<th>Size</th>"+
					"<th>Message</th>"+
					rows;

	html += "</table>"

	return html;
}


/***********************DIALOG BOXES*****************************/

function alert_modal_show(title,message,type)
{
	$('#alert-modal').modal({
	  backdrop: 'static',
	  keyboard: false
	});	
	
	$("#alert-modal-title-txt").text(title);
	$("#alert-modal-message-txt").text(message);
	$("#alert-modal-header").attr("class","modal-header bg-"+type);
	$("#alert-modal").modal('show');
}

function alert_modal_hide()
{
	$("#alert-modal").modal('hide');
}

function process_modal_show(title,message)
{
	$('#process-modal').modal({
	  backdrop: 'static',
	  keyboard: false
	});
	
	$("#process-modal-title-txt").text(title);
	$("#process-modal-message-txt").text(message);
	$("#process-modal").modal('show');
}

function process_modal_hide()
{
	$("#process-modal").modal('hide');
}

function yes_no_modal_show(title,message)
{
	$('#yes-no-modal').modal({
	  backdrop: 'static',
	  keyboard: false
	});	
	
	$("#yes-no-modal-title-txt").text(title);
	$("#yes-no-modal-message-txt").text(message);
	$("#yes-no-modal").modal('show');
}

function yes_no_modal_hide()
{
	$("#yes-no-modal").modal('hide');
}

function lister_modal_show(title,message,pkgs)
{	
	$('#lister-modal').modal({
	  backdrop: 'static',
	  keyboard: false
	});	
	
	$("#lister-modal-title-txt").text(title);
	$("#lister-modal-message-txt").text(message);
	$("#lister-modal-yes-btn").text("Okay");
	$("#lister-modal-no-btn").text("Cancel");

	$("#lister-modal-list").html("");
	for ( var i = 0; i < pkgs.length; i++ )
	{		
		$("#lister-modal-list").append(package_dependency_item(pkgs[i]));
	}

	$("#lister-modal").modal('show');
}

function lister_modal_hide()
{
	$("#lister-modal").modal('hide');
}

function download_result_modal_show(title,message,result)
{
	$('#download-result-modal').modal({
	  backdrop: 'static',
	  keyboard: false
	});	
	
	$("#download-result-modal-title-txt").text(title);
	$("#download-result-modal-message-txt").text(message);		
	$("#download-result-modal-body").html(download_result_table(result));
	$("#download-result-modal").modal('show');
}

function download_result_modal_hide()
{
	$("#download-result-modal").modal('hide');	
}

function preview_modal_show(pkg)
{	
	$.getJSON(_json_find_package+"?package="+pkg)
	.done(function(result){		
		if ( result.length == 0 )
			return;

		var curr_pkg = result[0];

		$('#preview-modal-download-btn').attr("class","btn btn-primary sr-only");
		$('#preview-modal-install-btn').attr("class","btn btn-primary sr-only");
		$('#preview-modal-mark-btn').attr("class","btn btn-default");		

		if ( result[0].status == "Downloaded" && _environment_data.original_computer == "true" )
			$('#preview-modal-install-btn').attr("class","btn btn-primary");
		else if ( result[0].status == "Available" || result[0].status == "Upgradable" )
			$('#preview-modal-download-btn').attr("class","btn btn-primary");
		else
			$('#preview-modal-mark-btn').attr("class","btn btn-default sr-only");		

		$("#preview-modal").attr("package-name",pkg);

		$.getJSON(_json_get_package_dependencies+"?package="+pkg)
		.done(function(result){
			
			$('#preview-modal-header').html(preview_modal_header(curr_pkg,result.overall_size));
			$('#preview-modal-dependency-list').html("");
			
			if ( result.unsatisfied.length > 0 )
			{
				$('#preview-modal-dependency-status-txt').text(result.unsatisfied.length + " package" + ((result.unsatisfied.length>1)?"s":"") +" to be downloaded");
				$('#preview-modal-install-btn').attr("class","btn btn-primary sr-only");
				$('#preview-modal-download-btn').attr("class","btn btn-primary");

				for ( var i = 0 ; i < result.unsatisfied.length ; i ++ )
					$('#preview-modal-dependency-list').append(package_dependency_item(result.unsatisfied[i]));
			}		
			else if ( result.unsatisfied.length == 0 && result.satisfied.length > 0 )
			{
				$('#preview-modal-dependency-status-txt').text("All dependencies were downloaded and ready to install");
				
				for ( var i = 0 ; i < result.satisfied.length ; i ++ )
					$('#preview-modal-dependency-list').append(package_dependency_item(result.satisfied[i]));
			}		
			else
			{
				$('#preview-modal-header').html(preview_modal_header(curr_pkg));
				$('#preview-modal-dependency-status-txt').text("All dependencies were satisfied");
			}

		})
		.fail(function(){    		
			alert("dependency-list json failed");		
		});
	});		
	
	$('#preview-modal-screenshot-img').attr("src","http://screenshots.ubuntu.com/screenshot/"+pkg);	
	
	$('#preview-modal').modal({
	  backdrop: 'static',
	  keyboard: false
	});

	//Reset and reassign events - To avoid double fire
	$(document).off("click","#preview-modal-download-btn");
	$(document).off("click","#preview-modal-install-btn");

	$(document).on("click","#preview-modal-download-btn",function(){		
		download_package($("#preview-modal").attr("package-name"));
		$("#preview-modal").attr("package-name","");	
	});

	$(document).on("click","#preview-modal-install-btn",function(){
		install_package($("#preview-modal").attr("package-name"));
		$("#preview-modal").attr("package-name","");
	});
	
	$("#preview-modal").modal('show');	
}

function preview_modal_hide()
{
	$("#preview-modal").modal('hide');
}

function download_modal_show()
{	
	$('#download-modal').modal({
	  backdrop: 'static',
	  keyboard: false
	});
	
	$("#download-modal").modal('show');

	
	var handler = setInterval ( function() {
		
		console.log('package dl : ' +  _system_status.package_downloading );
		if ( _system_status.package_downloading == "false" &&  _system_status.repository_downloading == "false" )
		{						
			download_modal_hide();
			on_download_finished();
			clearInterval(handler);
		}
		else
		{			
			$.getJSON(_json_get_package_download_status)
			.done(function(result){				
				$('#download-modal-overall-progress-success').attr("style","width: "+result.overall_progress_success+"%");
				$('#download-modal-overall-progress-failed').attr("style","width: "+result.overall_progress_failed+"%");
				$('#download-modal-overall-progress-success').text(result.overall_progress_success+"%");
				$('#download-modal-overall-progress-failed').text(result.overall_progress_failed+"%");
				
				$('#download-modal-current-progress-title').text("("+result.current_index+"/"+result.max_count+") " + result.current_item + " - " + result.current_size + " - " + result.current_transfer_rate);
				$('#download-modal-current-progress').attr("style","width: "+result.current_progress+"%");
				$('#download-modal-current-progress-text').text(result.current_progress+"%");
			});
		}

	},500);	
	
	//Events
	$(document).on("click","#download-modal-close-btn",function(){
		$.getJSON(_json_stop_download);
		$(document).off("click","#download-modal-close-btn");
	});
}

function download_modal_hide()
{
	$('#download-modal-overall-progress-success').attr("style","width: 0%");
	$('#download-modal-overall-progress-failed').attr("style","width: 0%");
	$('#download-modal-overall-progress-success').text("0%");
	$('#download-modal-overall-progress-failed').text("0%");
	$('#download-modal-current-progress-title').text("");
	$('#download-modal-current-progress').attr("style","width: 0%");
	$('#download-modal-current-progress-text').text("0%");

	$("#download-modal").modal('hide');
}

function project_select_modal_show()
{
	$('#project-select-modal').modal({
	  backdrop: 'static',
	  keyboard: false
	});
	
	$("#project-select-modal-noti").attr("class","alert alert-success text-center sr-only");
	$("#project-select-modal").modal('show');

	$(document).off("click","#project-select-modal-create-btn");	
	$(document).off("click","#project-select-modal-open-btn");

	$(document).on("click","#project-select-modal-open-btn",function(){
		var project = $("#project-select-modal-open-cbo option:selected").text();
		$.getJSON(_json_open_project+"?project="+project)
	    .done(function(result){	    	
	    	project_select_modal_hide();

	    	get_system_information();
	    	initialize_components_by_environment();

	    	_initialized = false;
	    	scan_repository();


	    });
	});

	if ( _environment_data.operating_system == "LINUX" )
	{
		$(document).on("click","#project-select-modal-create-btn",function(){
			var project = $("#project-select-modal-create-in").val();

			if ( project.length < 0 )
			{
				$("#project-select-modal-noti").attr("class","alert alert-danger text-center");
				$("#project-select-modal-noti").text("Invalid project name!");
				return;
			}

			$("#project-select-modal-noti").attr("class","alert alert-info text-center");
			$("#project-select-modal-noti").text("Creating project...");

			$.getJSON(_json_create_project+"?project="+project)
		    .done(function(result){	    	
		    	if (result.success == "true")
		    	{
			    	project_select_modal_refresh();
			    	$("#project-select-modal-noti").attr("class","alert alert-success text-center");
				}
				else			
					$("#project-select-modal-noti").attr("class","alert alert-danger text-center");	

				$("#project-select-modal-noti").text(result.message);
		    });	    
		});
	}
	else
	{
		$("#project-select-modal-create-in").attr("disabled","true");
		$("#project-select-modal-create-btn").attr("disabled","true");
	}

	project_select_modal_refresh();
	//<div class="alert alert-danger text-center" style="border-radius:0px;">Failed to create project</div>	
}

function project_select_modal_refresh()
{
	$("#project-select-modal-open-cbo").html("");
	$.getJSON(_json_get_projects)
    .done(function(result){
    	if ( result.length == 0 )
    	{
    		$("#project-select-modal-open-btn").attr("disabled","true");
    		$("#project-select-modal-open-cbo").attr("disabled","true");
    	}
    	else
    	{
    		$("#project-select-modal-open-btn").removeAttr("disabled");
    		$("#project-select-modal-open-cbo").removeAttr("disabled");
    	}

    	for ( var i = 0; i < result.length ; i++ )
			$("#project-select-modal-open-cbo").append("<option value=" + result[i].name + ">" + result[i].name + "</option>");
    });
}

function project_select_modal_hide()
{
	$("#project-select-modal").modal('hide');
}

function ppa_input_modal_show()
{
	$('#ppa-input-modal').modal({
		  backdrop: 'static',
		  keyboard: false
		});			

	$("#ppa-input-modal-title-txt").text("Add Personal Package Archive Repository");
	$("#ppa-input-modal-modal-noti").attr("class","alert alert-danger text-center sr-only");

	$(document).off("click","#ppa-input-modal-yes-btn");

	$(document).on("click","#ppa-input-modal-yes-btn",function(){
		var ppa = $("#ppa-input-modal-ppa-in").val();

		if ( ppa.indexOf("ppa:") == -1 )
		{			
			$("#ppa-input-modal-modal-noti").attr("class","alert alert-danger text-center");
			$("#ppa-input-modal-modal-noti").text("Invalid PPA Address");
			return;
		}
		
		$.getJSON(_json_check_ppa_exists+"?ppa="+ppa)
		.done(function(result){
			if ( result.exists == "true")
			{				
				$("#ppa-input-modal-modal-noti").attr("class","alert alert-danger text-center");
				$("#ppa-input-modal-modal-noti").text("PPA already exist!");
			}
			else
			{
				ppa_input_modal_hide();
				ppa_select_modal_show(ppa);
			}
		})
		.fail(function(){
			ppa_input_modal_hide();
		});
	});
	
	$("#ppa-input-modal").modal('show');
}

function ppa_input_modal_hide()
{
	$("#ppa-input-modal").modal('hide');
}

function ppa_select_modal_show(ppa)
{

	var lp_name = "";
	var ppa_name = "";
	var lp_link = "";

	ppa_trim = ppa.replace("ppa:","");
	lp_name = ppa_trim.split("/")[0];
	ppa_name = ppa_trim.split("/")[1];
	lp_link = __cors__ + "/https://launchpad.net/~"+lp_name+"/+archive/ubuntu/"+ppa_name;

	process_modal_show("Checking PPA","Please wait while we gather information about the given personal package archive...");

	$.ajax(lp_link)
	.done(function(data){	
		process_modal_hide();

		var ppa_title = $("#edit-displayname",data).text().trim();	
		var ppa_descrpition = $("#edit-description",data).text().replace("PPA description","").trim();
		var ppa_sources_list_entry = $("#sources-list-entries",data).text();
		var codename = "";
		var upstream_codename = "";
		var selected_series = null;

		ppa_sources_list_entry = ppa_sources_list_entry.replace(/deb-src/g,"%0Adeb-src");	

		$.ajax({
			url: _json_get_current_project,
			dataType: 'json',
			async: false,		
			success: function(data) {
		    	codename = data.codename;
		    	upstream_codename = data.upstream_codename;	    	
			}
		});

		var option = $('select[id="field.series"] option',data);
		var ppa_series = $.map(option,function(option) {
		    return option.value;
		});

		var ppa_series_description = $.map(option ,function(option) {
		    return option.text;
		});		

		$("#ppa-select-series-cbo").html("");
		for( var i = 1; i < ppa_series.length; i++ )
		{
			$("#ppa-select-series-cbo").append("<option value='"+ppa_series[i]+"'>"+ppa_series_description[i]+"</option>");
			if ( ppa_series[i] == codename )
				selected_series = codename;
			else if (ppa_series[i] == upstream_codename )
				selected_series = upstream_codename;
		}	

		if ( selected_series != null )
		{
			$("#ppa-select-series-cbo").val(selected_series);		
			ppa_sources_list_entry = ppa_sources_list_entry.replace(/YOUR_UBUNTU_VERSION_HERE/g,selected_series);
		}
		else
		{
			$("#ppa-select-modal-alert").attr("class","'alert alert-warning text-center");
			$("#ppa-select-modal-alert").text("Unable to determine appropriate series for your project. Please select it manually.");
		}
		
		$('#ppa-select-modal').modal({
		  backdrop: 'static',
		  keyboard: false
		});			

		$("#ppa-select-modal-title-txt").text("Add PPA : " + ppa_title);
		$("#ppa-select-modal-ppa-description-txt").text(ppa_descrpition);	
		$("#ppa-select-modal-alert").attr("class","'alert alert-warning text-center sr-only");	
		$("#ppa-select-modal").modal('show');

		$(document).off("click","#ppa-select-modal-yes-btn");

		$(document).on("click","#ppa-select-modal-yes-btn",function(){		
			$.getJSON(_json_add_ppa_repository+"?ppa="+ppa+"&sources_list_entry="+ppa_sources_list_entry+"&release="+selected_series)
			.done(function(result)
			{
				if ( result.success == "true")
				{
					alert_modal_show("Add Apt Repository Success","Successfully added PPA repository","primary");
					$(document).off("click","#alert-modal-yes-btn");
					$("#alert-modal-yes-btn").on("click",function(){
						download_ppa_repository(ppa);
					});
				}
				else
					alert_modal_show("Add Apt Repository Failed",result.message,"danger");
			})
			.fail(function(){
				alert("ppa-select-modal json failed");
			});
		});	
	})
	.fail(function(){
		process_modal_hide();
		alert_modal_show("Failed to check PPA","Unable to gather information about PPA.","danger");	
	});
}

function ppa_select_modal_hide()
{
	$("#ppa-select-modal").modal('hide');
}

function settings_modal_show()
{
	//Downloader
	var downloaders = "";
	var default_downloader = "";
	var default_downloader_parameters = "";

	//Installer
	var installers = "";
	var default_installer = "";
	var apt_get_parameters = "";
	var dpkg_parameters = "";
	var terminals = "";

	//Server
	var server_port = "";

	$.ajax({
		url: _json_get_configuration_entries,
		dataType: 'json',
		async: false,		
		success: function(data) {		
	    	downloaders = data.downloaders;
	    	default_downloader = data.default_downloader;
	    	default_downloader_parameters = data.default_downloader_parameters;

	    	installers = data.installers;
	    	default_installer = data.default_installer;
	    	apt_get_parameters = data.apt_get_parameters;
	    	dpkg_parameters = data.dpkg_parameters;
	    	terminals = data.terminals;

	    	server_port = data.server_port;    	
		}
	});

	//Downloader
	$("#settings-modal-downloaders-cbo").html("");
	var downloaders_arr = downloaders.split(",");
	for ( var i = 0; i < downloaders_arr.length; i++)
		$("#settings-modal-downloaders-cbo").append("<option value='"+downloaders_arr[i]+"'>"+downloaders_arr[i]+"</option>");

	$("#settings-modal-default-downloader-parameters-in").val(default_downloader_parameters);
	$("#settings-modal-downloaders-cbo").val(default_downloader);

	//Installer
	$("#settings-modal-installers-cbo").html("");
	var installers_arr = installers.split(",");
	for ( var i = 0; i < installers_arr.length; i++)
		$("#settings-modal-installers-cbo").append("<option value='"+installers_arr[i]+"'>"+installers_arr[i]+"</option>");

	$("#settings-modal-installers-cbo").val(default_installer);
	$("#settings-modal-apt-get-parameters-in").val(apt_get_parameters);
	$("#settings-modal-dpkg-parameters-in").val(dpkg_parameters);
	$("#settings-modal-terminals-in").val(terminals);

	//Server
	$("#settings-modal-server-port-in").val(server_port);

	$(document).off("click","#settings-modal-save-btn");
	$(document).off("click","#settings-modal-edit-sources-btn");

	$("#settings-modal-edit-sources-btn").on("click",function(){
		$.getJSON(_json_open_sources_list_file);
	});

	$("#settings-modal-save-btn").on("click",function(){
		var get_request = "";
	    
	    get_request += "default_downloader=" + $("#settings-modal-downloaders-cbo").val();
	    get_request += "&default_downloader_parameters=" + $("#settings-modal-default-downloader-parameters-in").val();

	    get_request += "&default_installer=" + $("#settings-modal-installers-cbo").val();
	    get_request += "&apt_get_parameters=" + $("#settings-modal-apt-get-parameters-in").val();
	    get_request += "&dpkg_parameters=" + $("#settings-modal-dpkg-parameters-in").val();
	    get_request += "&terminals=" + $("#settings-modal-terminals-in").val();

	    get_request += "&server_port=" + $("#settings-modal-server-port-in").val();

	    $.getJSON(_json_save_configuration_entries+"?"+get_request)
	    .done(function(result){
	    	if ( result.success == "false" )
	    		alert_modal_show("Configuration Save Failed",result.message,"danger");	    	
	    })
	    .fail(function(){
	    	alert("save configuration entries json failed");
	    });

	});

	$('#settings-modal').modal({
			  backdrop: 'static',
			  keyboard: false
	});
	$('#settings-modal-title-txt').text("Cube Settings")
	$('#settings-modal').modal('show');
}

function settings_modal_hide()
{
	$('#settings-modal').modal('hide');
}

/*********************INITIALIZATION FUNCTIONS*****************************/

function initialize_events()
{	
	/** Navigation Bar **/
	//Repository
	$(document).on("click","#reload-repository-btn", function(){ 
		scan_repository();
	});

	$(document).on("click","#add-ppa-repository-btn", function(){ 
		ppa_input_modal_show();
	});	

	//Download
	$(document).on("click","#download-repository-btn", function(){ 
		on_download_repository_triggered();	
	});	

	$(document).on("click","#download-all-marked-btn", function(){ 
		download_all_marked_packages();
	});

	//Install	
	$(document).on("click","#install-all-marked-btn", function(){ 
		install_all_marked_packages();
	});

	$(document).on("click","#install-all-satisfied-downloaded-btn", function(){ 
		install_all_satisfied_downloaded_packages();
	});

	//Update
	$(document).on("click","#update-system-btn", function(){ 
		update_system_triggered();
	});
	
	$(document).on("click","#update-project-btn", function(){ 
		update_project_triggered();
	});

	//Mark	
	$(document).on("click","#mark-all-upgradable-btn", function(){ 
		mark_all_upgradable_packages();
	});

	$(document).on("click","#mark-all-downloaded-btn", function(){ 
		mark_all_downloaded_packages();
	});

	$(document).on("click","#unmark-all-to-download-btn", function(){ 
		unmark_all_to_download_packages();
	});

	$(document).on("click","#unmark-all-to-install-btn", function(){ 
		unmark_all_to_install_packages();
	});

	//Settings
	$(document).on("click","#settings-btn", function(){ 
		settings_modal_show();
	});	

	/** Side Bar **/
	$(document).on("click",".section-list-item", function(){ 	   
	   $("#package-search-category-text").text($(this).attr("section-list-item-desc"));
	   get_package_items ( "section-list", $(this).attr("section-list-item-name") );
	});
	
	$(document).on("click",".main-list-item", function(){ 		
		$("#package-search-category-text").text($(this).attr("main-list-item-desc"));
		get_package_items ( "main-list", $(this).attr("main-list-item-name") );
	});

	/** Package List **/
	$(document).on("click",".package-item-btn", function(){ 
		preview_modal_show($(this).attr("package-item-name"));
	});

	$(document).on("click",".package-item-body", function(){ 
		preview_modal_show($(this).attr("package-item-name"));
	});
	
	$(document).on("mouseenter",".package-item", function(){
		$("#mark-to-download-btn-"+$(this).attr("package-item-name")).attr("class","mark-to-download-btn btn btn-success");
		$("#mark-to-install-btn-"+$(this).attr("package-item-name")).attr("class","mark-to-install-btn btn btn-success");

		$("#unmark-to-install-btn-"+$(this).attr("package-item-name")).html("<span class='glyphicon glyphicon-remove'></span>");
		$("#unmark-to-download-btn-"+$(this).attr("package-item-name")).html("<span class='glyphicon glyphicon-remove'></span>");
	});

	$(document).on("mouseleave",".package-item", function(){
		$("#mark-to-download-btn-"+$(this).attr("package-item-name")).attr("class","mark-to-download-btn btn btn-success sr-only");
		$("#mark-to-install-btn-"+$(this).attr("package-item-name")).attr("class","mark-to-install-btn btn btn-success sr-only");

		$("#unmark-to-install-btn-"+$(this).attr("package-item-name")).html("<span class='glyphicon glyphicon-ok'></span>");
		$("#unmark-to-download-btn-"+$(this).attr("package-item-name")).html("<span class='glyphicon glyphicon-ok'></span>");
	});	

	$(document).on("click",".mark-to-install-btn",function(){		
		mark_to_install_package($(this).attr("package-item-name"));
	});

	$(document).on("click",".unmark-to-install-btn",function(){		
		unmark_to_install_package($(this).attr("package-item-name"));
	});

	$(document).on("click",".mark-to-download-btn",function(){		
		mark_to_download_package($(this).attr("package-item-name"));
	});

	$(document).on("click",".unmark-to-download-btn",function(){		
		unmark_to_download_package($(this).attr("package-item-name"));
	});	
	
	$(document).on("click","#package-search-btn", function(){
	   get_package_items ( "package-search", $("#package-search-in").val() );
	});	

	$('#package-list-end-div').appear();
	$('#package-list-end-div').on('appear', function(event, $all_appeared_elements) {      		
		if ( $("#package-list-end-div").attr("is-end") == "false" )
			get_next();
	});

	/** Search Bar **/

	$(document).on("keypress","#package-search-in", function(e){
		if (e.keyCode == 13) //Enter key pressed
			$("#package-search-btn").trigger("click");
	});
	
}

function initialize_lists ( )
{	
	get_main_lists ();
	get_section_lists ();
}

function initialize_package_list ()
{
	//Show available pckages at startup	
	$("#package-search-category-text").text("Available Packages");
	get_package_items ( "main-list","available" );
}


/*********************COMMANDS FUNCTIONS*****************************/

//Startup
function startup()
{	
	//Get System Information
	$("#server-status-noti").attr("class","alert alert-danger text-center sr-only");

	var handler = setInterval ( function() {
		var result = get_system_information();

		if ( result )
		{
			$("#server-status-noti").attr("class","alert alert-danger text-center sr-only");

			//Start the background server status check
			bg_check_status();
			
			//Initialize component events
			initialize_events();

			//Initialize components based on running environment data
			initialize_components_by_environment();
			
			clearInterval(handler);
		}
		else
		{
			$("#server-status-noti").attr("class","alert alert-danger text-center");
			$("#server-status-noti").text("Cube Server is Offline");
		}

	},1000);
}

function get_system_information()
{
	_cube_data = null;
	_environment_data = null;
	result = false;

	$.ajax({
		url: _json_get_cube_data,
		dataType: 'json',
		async: false,		
		success: function(data) {
	    	_cube_data = data;
	    	result = true;
		}
	});

	$.ajax({
		url: _json_get_environment_data,
		dataType: 'json',
		async: false,		
		success: function(data) {
	    	_environment_data = data;
	    	result = true;
		}
	});

	return result;
}

function initialize_components_by_environment()
{
	if ( _environment_data.original_computer == "false" )
	{
		$("#install-drop").hide();
		$("#system-drop").hide();
	}
	else
	{
		$("#install-drop").show();
		$("#system-drop").show();
	}
}

function refresh_package_list()
{
	var package_names = "";	
	$(".package-item").each(function(){
		package_names += this.id + ";";		
	});

	refresh_package(package_names);
}

function refresh_package(package_names)
{
	$.getJSON(_json_find_package + "?package=" + package_names)
	.done(function(result){
		for ( i = 0; i < result.length; i++ )
		{			
			$("#package-item-body-"+result[i].name).html ( package_item_body(result[i]) );			
		}
	});
}

function on_project_startup()
{
	//If not visible
	if ( !$('#project-select-modal').hasClass('in') )
		 project_select_modal_show();
}

//Scan Repositories
function scan_repository ()
{	
	$.getJSON( _json_scan_repositories )
	.fail(function(){
		alert("scan-repository json failed");
	});
}

function scan_status_repository()
{
	$.getJSON( _json_scan_repositories+"?mode=status-file-only" )
	.fail(function(){
		alert("scan-repository json failed");
	});	
}

function on_scan_repository_started()
{	
	process_modal_show("Scanning Repositories","Please wait while we scan all of your project repositories...");

	var handler = setInterval ( function() {
		if ( _system_status.repository_scanning == "false" )
		{
			on_scan_repository_finished();
			clearInterval(handler);
		}
	},500);
}

function on_scan_repository_finished()
{	
	process_modal_hide();
	if ( !_initialized )
	{
		_initialized = true;
		initialize_package_list();
	}
	else
		refresh_package_list();

	initialize_lists();	
}

//Download Packages/Repositories
function download_package ( pkg )
{	
	_download_mode = "package";
	$.getJSON( _json_download_package+"?package="+pkg )
	.fail(function(){
		alert("download-package json failed");
	});
}

function on_download_repository_triggered(scan_when_cancelled)
{
	//Reset and reassign Events
	$(document).off("click","#yes-no-modal-yes-btn");
	$(document).off("click","#yes-no-modal-no-btn");

	$(document).on("click","#yes-no-modal-yes-btn",function(){
		download_repository();
	});

	if ( scan_when_cancelled )
	{
		$(document).on("click","#yes-no-modal-no-btn",function(){
			scan_repository();
		});		
	}

	yes_no_modal_show('Download Repository','This will download the latest repositories available.');
}

function download_repository ( )
{	
	_download_mode = "repository";
	$.getJSON( _json_download_repository )
	.fail(function(){
		alert("download-repository json failed");
	});
}

function download_ppa_repository (ppa)
{
	_download_mode = "repository";
	$.getJSON( _json_download_repository+"?ppa="+ppa )
	.fail(function(){
		alert("download-repository json failed");
	});	
}

function on_download_started()
{
	//If not visible
	if ( !$('#download-modal').hasClass('in') )
		 download_modal_show();
}

function on_download_finished()
{	
	initialize_lists();
	refresh_package_list();

	show_download_result(_download_mode);
}

//Install Packages
function install_package ( pkg )
{
	$.getJSON( _json_install_package+"?package="+pkg )
	.fail(function(){
		alert("install-package json failed");
	});
}

function on_install_started()
{
	process_modal_show("Installing Packages","Please wait while we install your selected applications...")
	var handler = setInterval ( function() {
		if ( _system_status.package_installing == "false" )
		{
			on_install_finished();
			clearInterval(handler);			
		}
	},1000);
}

function on_install_finished()
{	
	process_modal_hide();

	$.getJSON( _json_get_install_package_result )
	.done(function(result){
		if ( result.success == "true" )
			scan_status_repository();
		else
			alert_modal_show("Installation Failed",result.message,"danger");
	});	
}

//Update System
function update_system_triggered()
{
	//Reset and reassign Events
	$(document).off("click","#yes-no-modal-yes-btn");
	$(document).off("click","#yes-no-modal-no-btn");

	$(document).on("click","#yes-no-modal-yes-btn",function(){
		update_system();
	});

	yes_no_modal_show('Update System','This will transfer all newly downloaded repositories from your project to your computer.');
}

function update_system()
{
	$.getJSON( _json_update_system )
	.done(function(result){
		if ( result.success == "true" )
			on_update_system_started();
		else
			alert('Update System Failed');
	})
	.fail(function(){
		alert("update-system json failed");
	});
}

function on_update_system_started()
{
	process_modal_show("Updating System","Please wait while we are updating your system...")
	setTimeout( function() { //Wait for 2 seconds
		var handler = setInterval ( function() {			
			if ( _system_status.system_updating == "false" )
			{
				console.log(_system_status.system_updating);
				on_update_system_finished();
				clearInterval(handler);
			}
		},1000);
	},2000);
}

function on_update_system_finished()
{
	process_modal_hide();

	$.getJSON( _json_get_update_system_result )
	.done(function(result){
		if ( result.success == "false" )
			alert_modal_show("Update System Failed",result.message,"danger");
	});

}

//Update Project
function update_project_triggered()
{
	//Reset and reassign Events
	$(document).off("click","#yes-no-modal-yes-btn");
	$(document).off("click","#yes-no-modal-no-btn");

	$(document).on("click","#yes-no-modal-yes-btn",function(){
		update_project();
	});

	yes_no_modal_show('Update Project','This will update your project for newly installed applications on your computer');
}

function update_project()
{
	$.getJSON( _json_update_project )
	.done(function(result){
		if ( result.success == "true" )
			on_update_project_started();
		else
			alert('Update Project Failed');
	})
	.fail(function(){
		alert("update-project json failed");
	});
}

function on_update_project_started()
{
	process_modal_show("Updating Project","Please wait while we are updating your project...")
	setTimeout( function() { //Wait for 2 seconds
		var handler = setInterval ( function() {			
			if ( _system_status.project_updating == "false" )
			{
				console.log(_system_status.project_updating);
				on_update_project_finished();
				clearInterval(handler);
			}
		},1000);
	},2000);
}

function on_update_project_finished()
{
	process_modal_hide();

	$.getJSON( _json_get_update_project_result )	
	.done(function(result){
		if ( result.success == "true" )
			scan_status_repository();
		else
			alert_modal_show("Update Project Failed",result.message,"danger");
	});
}

//Mark Package
function mark_all_upgradable_packages()
{
	$.getJSON( _json_mark_package+"?type=all-upgradable" )
	.done(function(result){		
		get_main_lists ();
		refresh_package(package_name);
	});
}

function mark_all_downloaded_packages()
{
	$.getJSON( _json_mark_package+"?type=all-downloaded" )
	.done(function(result){		
		get_main_lists ();
		refresh_package(package_name);
	});
}

function mark_to_download_package (package_name)
{
	$.getJSON( _json_mark_package+"?type=to-download&package="+package_name )
	.done(function(result){		
		get_main_lists ();
		refresh_package(package_name);
	});
}

function unmark_to_download_package (package_name)
{
	$.getJSON( _json_unmark_package+"?type=to-download&package="+package_name )
	.done(function(result){
		get_main_lists ();
		refresh_package(package_name);
	});
}

function unmark_all_to_download_packages ()
{
	$.getJSON( _json_unmark_package+"?type=all-to-download" )
	.done(function(result){
		get_main_lists ();
		refresh_package_list();
	});	
}

function mark_to_install_package (package_name)
{
	$.getJSON( _json_mark_package+"?type=to-install&package="+package_name )
	.done(function(result){
		get_main_lists ();
		refresh_package(package_name);
	});
}

function unmark_to_install_package (package_name)
{
	$.getJSON( _json_unmark_package+"?type=to-install&package="+package_name )
	.done(function(result){
		get_main_lists ();
		refresh_package(package_name);
	});
}

function unmark_all_to_install_packages ()
{
	$.getJSON( _json_unmark_package+"?type=all-to-install" )
	.done(function(result){
		get_main_lists ();
		refresh_package_list();
	});	
}

function download_all_marked_packages ()
{
	$.getJSON( _json_get_marked_packages + "?type=to-download&count=-1" )
	.done(function(result){
		
		if ( result.length == 0 )
			return;

		var pkgs = "";
		for ( var i = 0; i < result.length; i++ )
			pkgs += result[i].name + ";";

		$.getJSON( _json_get_package_dependencies + "?package=" + pkgs )
		.done(function(result){			

			if ( result.unsatisfied.length == 0 )
				return;

			lister_modal_show("To Download Packages","A total of " + result.unsatisfied_size + " from these " + result.unsatisfied.length + " packages will be downloaded",result.unsatisfied);			
			$(document).off("click","#lister-modal-yes-btn");

			$(document).on("click","#lister-modal-yes-btn",function(){
				lister_modal_hide();
				download_package(pkgs);
			});
		});
	});
}

function install_all_marked_packages()
{
	$.getJSON( _json_get_marked_packages + "?type=to-install&count=-1" )
	.done(function(result){
		
		if ( result.length == 0 )
			return;

		var pkgs = "";
		for ( var i = 0; i < result.length; i++ )
			pkgs += result[i].name + ";";

		$.getJSON( _json_get_package_dependencies + "?package=" + pkgs )
		.done(function(result){			

			if ( result.satisfied.length == 0 )
				return;

			if ( result.unsatisfied.length > 0 )
			{
				lister_modal_show("Unsatisfied dependencies","The following packages needs to be downloaded first",result.unsatisfied);
				$(document).off("click","#lister-modal-yes-btn");

				$("#lister-modal-yes-btn").text("Mark all to download");
				$(document).on("click","#lister-modal-yes-btn",function(){
					lister_modal_hide();

					var pkgs = "";
					for( var i = 0; i < result.unsatisfied.length; i++ )
						pkgs += result.unsatisfied[i].name + ";";
					
					mark_to_download_package(pkgs);
				});
			}
			else
			{
				lister_modal_show("To Install Packages","The following "+result.satisfied.length+" packages will be installed",result.satisfied);
				$(document).off("click","#lister-modal-yes-btn");

				$(document).on("click","#lister-modal-yes-btn",function(){
					lister_modal_hide();
					install_package(pkgs);
				});
			}
			
		});
	});
}

function install_all_satisfied_downloaded_packages()
{	
	$.getJSON(_json_get_satisfied_downloaded_packages)
	.done(function(result){

		if ( result.length == 0 )
			return;

		lister_modal_show("To Install Packages","The following "+result.length+" packages will be installed",result);
		$(document).off("click","#lister-modal-yes-btn");

		$(document).on("click","#lister-modal-yes-btn",function(){

			var pkgs = "";
			for( var i = 0; i < result.length; i++ )
				pkgs += result[i].name + ";";

			lister_modal_hide();
			install_package(pkgs);
		});
	});
}

function show_download_result(mode)
{
	var json = "";

	if ( mode == "package" )
		json = _json_get_download_package_result;
	else if ( mode == "repository" )
		json = _json_get_download_repository_result;

	$.getJSON( json )
	.done(function(result){
		if ( result.failed.length > 0 )
			download_result_modal_show("Download Result","The following "+result.failed.length+" items failed to be downloaded",result.failed);
	});
}

/*********************BACKGROUND FUNCTIONS*****************************/

function bg_check_status()
{
	setInterval ( function() {
		get_server_status();		
	},1000);
}


/***********************NON FUNCTION**********************************/

startup();

});